#include <stdint.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

void timer0Interrupt(void* context){
	static uint8_t i = 0;

	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);

	IOWR_ALTERA_AVALON_PIO_DATA(LED_BASE, ~(i++));
}

int main()
{ 
	alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);

	IOWR_ALTERA_AVALON_TIMER_PERIODH(TIMER0_BASE, (25000000UL-1UL)>>16);
	IOWR_ALTERA_AVALON_TIMER_PERIODL(TIMER0_BASE, (25000000UL-1UL));


	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
	ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK );

	/* Event loop never exits. */
	while (1);

	return 0;
}
