#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_pio_regs.h"

#include "KBD.h"

uint8_t kbd_read(void){
	uint16_t actual = IORD_ALTERA_AVALON_PIO_DATA(KBD_PIO_BASE);
	if(!(actual & KBD_S1_M)) return KBD_S1;
	if(!(actual & KBD_S2_M)) return KBD_S2;
	if(!(actual & KBD_S3_M)) return KBD_S3;
	return KBD_NONE;
}

void kbdCheck(void){
	static uint32_t kbd_time=0;
	static uint8_t last_kbd;
	static enum {KBD_IDLE, KBD_DEBOUNCE_WAIT, KBD_HOLD_WAIT, KBD_HOLD} kbd_state;


	uint8_t act_kbd = kbd_read(); //  odczytujemy wcinity przycisk

	if(kbd_time) kbd_time--; //  jeli trzeba odmierza czas to go odmierzamy

	if(act_kbd == KBD_NONE){ //  jeli wszystkie przyciski puszczono
		if(kbd_state == KBD_HOLD_WAIT){ //  i by odmierzony czas kliknicia
			if(menu_items[last_kbd].click.action)
				menu_items[last_kbd].click.action(menu_items[last_kbd].click.parameter); //  to wywoujemy funkcj kliknicia
		}
		kbd_state = KBD_IDLE; //  i resetujemy system
	}else{ //  w przeciwnym wypadku
		if(kbd_state == KBD_IDLE){ //  jeli to nowe przycinicie
			kbd_state = KBD_DEBOUNCE_WAIT; //  przechodzimy do fazy redukowania drga stykw
			kbd_time = CLICK_MIN; //  ustawiamy czas redukcji drga
			last_kbd = act_kbd; //  i zapamitujemy aktualnie wcinity przycisk
		}else if(kbd_state == KBD_DEBOUNCE_WAIT){ //  jeli jestemy w trybie eleminiacji drga stykw
			if(last_kbd == act_kbd){ //  jeli nadal ten sam przycisk
				if(kbd_time == 0){ //  jeli ju upyn cay czas
					kbd_state = KBD_HOLD_WAIT; //  to przechodzimy do opcji wyzwalania kliknicia i odmierzenia czasu trzymania
					kbd_time = HOLD_MIN; //  ustawiamy czas przytrzymania
				}
			}else{ //  jeli zmieni si przycisk
				kbd_state = KBD_IDLE; //  to resetujemy system
			}
		}else if(kbd_state == KBD_HOLD_WAIT){ //  jeli oczekujemy na przytrzymanie
			if(last_kbd == act_kbd){ //  jeli nadal ten sam przycisk
				if(kbd_time == 0){ //  jeli ju upyn cay czas
					kbd_state = KBD_HOLD; //  to przechodzimy do opcji powtarzania klikni
					kbd_time = HOLD_REP; //  ustawiamy czas przytrzymania
					if(menu_items[last_kbd].hold.action)
						menu_items[last_kbd].hold.action(menu_items[last_kbd].hold.parameter); //  to wywoujemy funkcj przytrzymania
				}
			}else{ //  jeli zmieni si przycisk
				kbd_state = KBD_IDLE; //  to resetujemy system
			}
		}else if(kbd_state == KBD_HOLD){
			if(last_kbd == act_kbd){ //  jeli nadal ten sam przycisk
				if(kbd_time == 0){ //  jeli ju upyn cay czas
					kbd_state = KBD_HOLD; //  to przechodzimy do opcji powtarzania klikni
					kbd_time = HOLD_REP; //  ustawiamy czas przytrzymania
					if(menu_items[last_kbd].hold.action)
						menu_items[last_kbd].hold.action(menu_items[last_kbd].hold.parameter); //  to wywoujemy funkcj przytrzymania
				}
			}else{ //  jeli zmieni si przycisk
				kbd_state = KBD_IDLE; //  to resetujemy system
			}
		}
	}
}
