#include <stdint.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

#include "7SEG.h"

void timer0Interrupt(void* context){
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);
	refreshDisplay();
}

void SWInterrupt(void* context){
	static uint16_t counter = 0;

	IOWR_ALTERA_AVALON_PIO_EDGE_CAP(SW_BASE, 0);

	counter++;
	intDisplayDec(counter);
}


int main()
{ 
	alt_putstr("Hello from Nios II!\n");

	alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);
	
	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
		ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK );
		
	alt_ic_isr_register(SW_IRQ_INTERRUPT_CONTROLLER_ID, SW_IRQ, SWInterrupt, NULL, NULL);

	IOWR_ALTERA_AVALON_PIO_IRQ_MASK(SW_BASE, 0b111);

	intDisplayDec(0);

	/* Event loop never exits. */
	while (1){

	}

	return 0;
}
