#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"

#include "altera_avalon_pio_regs.h"

#include "i2c.h"

#include "bmp280.h"
#include "mcp23x08.h"
#include "mcp23x08_regs.h"


int32_t temp;
uint32_t press;


int main()
{
	alt_putstr("Pomiar temperatury i cisnienia\r\n");

	i2cSetSpeed(I2C_BASE, I2C_FREQ, 50000);
	i2cInit(I2C_BASE);

	BMP280Reset();

	if(!BMP280Verify()){
		alt_putstr("Blad BMP280\r\n");
	}

	BMP280Init();

	MCP23X08writeReg(0, MCP23x08_IODIR, 0x0F);
	MCP23X08writeReg(0, MCP23x08_GPPU, 0x0F);

	MCP23X08writeReg(1, MCP23x08_IODIR, 0xFF);
	MCP23X08writeReg(1, MCP23x08_GPPU, 0xFF);

	while(1){
		temp = BMP280ConvertT(BMP280ReadT());
		press = BMP280ConvertP(BMP280ReadP());
		printf("%07ld %07lu\r\n", temp, press);

		uint8_t data = MCP23X08readReg(0, MCP23x08_GPIO);
		MCP23X08writeReg(0, MCP23x08_GPIO, ~(data << 4));

		data = MCP23X08readReg(1, MCP23x08_GPIO);
		IOWR_ALTERA_AVALON_PIO_DATA(LED_BASE, data);
		ALT_USLEEP(100000);
	}

	return 0;
}
