#ifndef KBD_H_
#define KBD_H_

#include <stdint.h>

//definicje aliasw dla przyciskw
#define KBD_NONE	255
#define KBD_S		0
#define KBD_L		1
#define KBD_D		2
#define KBD_U		3
#define KBD_R		4

//definiujemy progi dla klawiatury analogowej
#define KBD_N_S_TRH	2985
#define KBD_S_L_TRH	2354
#define KBD_L_D_TRH	1766
#define KBD_D_U_TRH	1084
#define KBD_U_R_TRH	347


//minimalny czas dobouncingu (podawany w ms)
#define CLICK_MIN 50
//minimalny czas przytrzymania
#define HOLD_MIN 250
//powtarzanie po przytrzymaniu
#define HOLD_REP 70


//struktura elementu menu ze wskanikiem na funkcj oraz parametrem jej wywoania
typedef struct
{
	void (*action)(uint8_t);
	uint8_t parameter;
}menu_action_t;

//struktura uwzgldniaja akcj dla kliknicia i przytrzymania
typedef struct
{
	menu_action_t click;
	menu_action_t hold;
}menu_item_t;

//tabela struktur - dla kadego przycisku
menu_item_t menu_items[5];

void kbdCheck(uint32_t adcValue);


#endif /* KBD_H_ */
