#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"

#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

#include "KBD.h"
#include "adc.h"

void timer0Interrupt(void* context){
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);
	uint32_t adcData[2];
	adcReadCont(adcData,2);
	kbdCheck(adcData[1]);
}

void kbdCallbackClick(uint8_t param){
	printf("Click\t %u\r\n", param);
}

void kbdCallbackHold(uint8_t param){
	printf("Hold\t %u\r\n", param);
}

int main()
{ 
	//Inicjalizacja ADC
	adcInitCont();

	//szybkie wypełnienie tablic definiujących akcje przycisków
	for(int i = 0 ; i < 5 ; i++){
		menu_items[i].click.action = kbdCallbackClick;
		menu_items[i].click.parameter = i;
		menu_items[i].hold.action = kbdCallbackHold;
		menu_items[i].hold.parameter = i;
	}

	//Ustawienie przerwania od timera i uruchomienie timera
	alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);
	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
		ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK);


	while (1){

	}

	return 0;
}
