#include <stdint.h>
#include <io.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "sys/alt_irq.h"


int main()
{ 
	alt_putstr("Hello from Nios II!\n");

	// ustawiamy czasy konieczne do wygenerowania prawidłowych przebiegów sterujących
	IOWR_32DIRECT(WS2812_0_BASE,  0, (NIOS2_CPU_FREQ * 350LL)   / 1000000000LL);
	IOWR_32DIRECT(WS2812_0_BASE,  4, NIOS2_CPU_FREQ * 900LL   / 1000000000LL);
	IOWR_32DIRECT(WS2812_0_BASE,  8, NIOS2_CPU_FREQ * 900LL   / 1000000000LL);
	IOWR_32DIRECT(WS2812_0_BASE, 12, NIOS2_CPU_FREQ * 350LL   / 1000000000LL);
	IOWR_32DIRECT(WS2812_0_BASE, 16, NIOS2_CPU_FREQ * 100000LL / 1000000000LL);

	IOWR_32DIRECT(WS2812_0_BASE, 20, 0x00FF00);
	IOWR_32DIRECT(WS2812_0_BASE, 24, 0x0000FF);


	uint32_t temp;
	while (1){
		// 0x00FF00
		// 0x0000FF
		for( int i = 0 ; i < 255 ; i++){
			temp = IORD_32DIRECT(WS2812_0_BASE, 20);
			temp += 0x000001;
			temp -= 0x000100;
			IOWR_32DIRECT(WS2812_0_BASE, 20, temp);

			temp = IORD_32DIRECT(WS2812_0_BASE, 24);
			temp += 0x000100;
			temp -= 0x000001;
			IOWR_32DIRECT(WS2812_0_BASE, 24, temp);

			ALT_USLEEP(5000);
		}
		// 0x0000FF
		// 0x00FF00
		for( int i = 0 ; i < 255 ; i++){
			temp = IORD_32DIRECT(WS2812_0_BASE, 20);
			temp += 0x010000;
			temp -= 0x000001;
			IOWR_32DIRECT(WS2812_0_BASE, 20, temp);

			temp = IORD_32DIRECT(WS2812_0_BASE, 24);
			temp += 0x010000;
			temp -= 0x000100;
			IOWR_32DIRECT(WS2812_0_BASE, 24, temp);

			ALT_USLEEP(5000);
		}
		// 0xFF0000
		// 0xFF0000
		for( int i = 0 ; i < 255 ; i++){
			temp = IORD_32DIRECT(WS2812_0_BASE, 20);
			temp += 0x000100;
			temp -= 0x010000;
			IOWR_32DIRECT(WS2812_0_BASE, 20, temp);

			temp = IORD_32DIRECT(WS2812_0_BASE, 24);
			temp += 0x000001;
			temp -= 0x010000;
			IOWR_32DIRECT(WS2812_0_BASE, 24, temp);

			ALT_USLEEP(5000);
		}


	}

	return 0;
}
